library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
use work.types.all;

entity routepath_calc is
  port (
    routepath     : in  std_logic_vector(routepath_length-1 downto 0);
    new_routepath : out std_logic_vector(routepath_length-1 downto 0));
end routepath_calc;

architecture behavior of routepath_calc is
  signal temp_routepath : std_logic_vector(routepath_length-1 downto 0);
  signal direction      : std_logic_vector(1 downto 0);
  signal new_direction  : std_logic_vector(1 downto 0);


begin  -- behavior
  -- 
  RoutePath_Calc : process (routepath, direction)
    variable i   : integer := 0;
  begin
    for i in 0 to routepath_length/2-1 loop
      direction                                                                  <= routepath(2*i+1 downto 2*i);
      case direction is
        when N      =>
          new_direction                                                          <= S;
        when E      =>
          new_direction                                                          <= W;
        when S      =>
          new_direction                                                          <= N;
        when W      =>
          new_direction                                                          <= E;
        when others => null;
      end case;
      temp_routepath(2*(routepath_length/2-1-i)+1 downto 2*(routepath_length/2-1-i)) <= new_direction;
    end loop;  -- i 
    new_routepath                                                                <= temp_routepath;
  end process RoutePath_Calc;
end behavior;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
use work.types.all;

package outepath_calc is
  component routepath_calc
    port (
      routepath     : in  std_logic_vector(routepath_length-1 downto 0);
      new_routepath : out std_logic_vector(routepath_length-1 downto 0));
  end component;
end outepath_calc;
