library ieee;
use std.textio.all;
use ieee.std_logic_1164.all;
use ieee.std_logic_textio.all;
use work.types.all;
use work.Depack.all;

entity test_source_DecapTable is
  port(clk     : out bit_t;
       reset   : out bit_t;
       -- Network Interface Signals
       empty   : out std_logic_vector(num_vc-1 downto 0);
       get     : in  std_logic_vector(num_vc-1 downto 0);
       inChSel : in  std_logic_vector(chSelect-1 downto 0);
       inFlit  : out std_logic_vector(flit_size-1 downto 0));
end test_source_DecapTable;

architecture behav of test_source_DecapTable is
begin
  process (clk)
  begin  -- process
    if clk'event and clk = '1' then  -- rising clock edge
       empty <=  ""  
    end if;
  end process;
  a <= "00", "01" after 10 ns, "00" after 20 ns, "10" after 30 ns,
       "00"       after 40 ns, "01" after 50 ns, "00" after 60 ns, "10" after 70 ns, "00" after 80 ns;
  b <= "00", "01" after 5 ns, "00" after 15 ns, "01" after 25 ns,
       "00"       after 35 ns, "10" after 45 ns, "00" after 55 ns, "10" after 65 ns, "00" after 75 ns;

end behav;




library ieee;
use std.textio.all;
use ieee.std_logic_1164.all;
use ieee.std_logic_textio.all;
use work.types.all;

entity test_sink_DecapTable is
  port(RdData : in Reg);
end test_sink_DecapTable;

architecture behav of test_sink_and is
begin

end behav;




library ieee;
use std.textio.all;
use ieee.std_logic_1164.all;
use ieee.std_logic_textio.all;
use work.and1of2_pkg.all;
use work.types.all;

entity system_DecapTable is
end system_DecapTable;

architecture struct of system_DecapTable is

  component clock
    generic (
      period :     time      := 50 ns);
    port (
      clk    : out std_logic := '0');
  end component;

  component test_source_DecapTable
    port(clk   : out bit_t;
         reset : out bit_t;
         -- Network Interface signals


         RegWrite : out bit_t;
         WrReg    : out std_logic_vector(chSelect downto 0);
         WrData   : out priority);
  end component;

  component test_sink_DecapTable
    port(RdData : in Reg);
  end component;

  signal a, b, y          : ch_1of2;
  signal acka, ackb, acky : std_logic;


begin


  reset <= '0', '1' after 57 ns;

  sysClk : clock
    port map (
      clk => clk);

  src : test_source_DecapTable
    port map(a => a, b => b, acka => acka, ackb => ackb);

  snk : test_sink_DecapTable
    port map(y => y, acky => acky);



end struct;

configuration conf_DecapTable of system_DecapTable is
  for struct
    for and_cmp : and1of2
    use entity work.and1of2(structural);
end for;
for src         : test_source_and
  use entity work.test_source_and(behav);
end for;
for snk         : test_sink_and
  use entity work.test_sink_and(behav);
end for;
end for;
end conf_DecapTable;
