library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
use work.types.all;
use work.decap_pkg.all;

library ieee;
use IEEE.STD_LOGIC_TEXTIO.all;
use STD.TEXTIO.all;

entity testbench is
end testbench;

architecture testbench_arch of testbench is
-- If you get a compiler error on the following line,
-- from the menu do Options->Configuration select VHDL 87
  file RESULTS   :     text open write_mode is "results.txt";
  component decap_environment
    port (
      clk        : in  std_logic;
      reset      : in  std_logic;
      SBA        : in  std_logic_vector (7 downto 0);
      empty      : in  std_logic_vector (7 downto 0);
      get        : out std_logic_vector (7 downto 0);
      inChannels : in  channel_type
      );
  end component;

  signal clk        : std_logic;
  signal reset      : std_logic;
  signal SBA        : std_logic_vector (7 downto 0);
  signal empty      : std_logic_vector (7 downto 0);
  signal get        : std_logic_vector (7 downto 0);
  signal inChannels : channel_type;

begin
  UUT : decap_environment
    port map (
      clk        => clk,
      reset      => reset,
      SBA        => SBA,
      empty      => empty,
      get        => get,
      inChannels => inChannels
      );

  process                               -- clock process for clk,
  begin
    CLOCK_LOOP : loop
      clk <= transport '0';
      wait for 10 ns;
      clk <= transport '1';
      wait for 10 ns;
      wait for 40 ns;
      clk <= transport '0';
      wait for 40 ns;
    end loop CLOCK_LOOP;
  end process;

  process                               -- Process for clk
  begin
    -- --------------------
    reset         <= transport '1';
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("11111111");  --0
    inChannels(0) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(1) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(2) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(3) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000000000000000");  --0
    -- --------------------
    wait for 100 ns;                    -- Time=100 ns
    reset         <= transport '0';
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("11111101");  --FD
    inChannels(0) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(1) <= transport std_logic_vector'("01110011100011110");  --E71E
    inChannels(2) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(3) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000000000000000");  --0
    -- --------------------
    wait for 100 ns;                    -- Time=200 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("11111101");  --FD
    inChannels(0) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(1) <= transport std_logic_vector'("01111101000100011");  --FA23
    inChannels(2) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(3) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000000000000000");  --0
    -- --------------------
    wait for 100 ns;                    -- Time=300 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("11111101");  --FD
    inChannels(0) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(1) <= transport std_logic_vector'("00010011110100000");  --27A0
    inChannels(2) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(3) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000000000000000");  --0
    -- --------------------
    wait for 100 ns;                    -- Time=400 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("11111100");  --FC
    inChannels(0) <= transport std_logic_vector'("01110011100011110");  --E71E
    inChannels(1) <= transport std_logic_vector'("01001110000110100");  --9C34
    inChannels(2) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(3) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000000000000000");  --0
    -- --------------------
    wait for 100 ns;                    -- Time=500 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("11111100");  --FC
    inChannels(0) <= transport std_logic_vector'("01110011100011110");  --E71E
    inChannels(1) <= transport std_logic_vector'("00001001000110100");  --1234
    inChannels(2) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(3) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000000000000000");  --0
    -- --------------------
    wait for 100 ns;                    -- Time=600 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("11111100");  --FC
    inChannels(0) <= transport std_logic_vector'("01110011100011110");  --E71E
    inChannels(1) <= transport std_logic_vector'("10101011001111000");  --15678
    inChannels(2) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(3) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000000000000000");  --0
    -- --------------------
    wait for 100 ns;                    -- Time=700 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("11110110");  --F6
    inChannels(0) <= transport std_logic_vector'("01110011100011110");  --E71E
    inChannels(1) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(2) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(3) <= transport std_logic_vector'("01110000101111110");  --E17E
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000000000000000");  --0
    -- --------------------
    wait for 100 ns;                    -- Time=800 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("11110110");  --F6
    inChannels(0) <= transport std_logic_vector'("01111110100100011");  --FD23
    inChannels(1) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(2) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(3) <= transport std_logic_vector'("01110000101111110");  --E17E
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000000000000000");  --0
    -- --------------------
    wait for 100 ns;                    -- Time=900 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("11110110");  --F6
    inChannels(0) <= transport std_logic_vector'("00100000001010000");  --4050
    inChannels(1) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(2) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(3) <= transport std_logic_vector'("01110000101111110");  --E17E
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000000000000000");  --0
    -- --------------------
    wait for 100 ns;                    -- Time=1000 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("11110110");  --F6
    inChannels(0) <= transport std_logic_vector'("00000000111111111");  --1FF
    inChannels(1) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(2) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(3) <= transport std_logic_vector'("01110000101111110");  --E17E
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000000000000000");  --0
    -- --------------------
    wait for 100 ns;                    -- Time=1100 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("11110110");  --F6
    inChannels(0) <= transport std_logic_vector'("00000000000000001");  --1
    inChannels(1) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(2) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(3) <= transport std_logic_vector'("01110000101111110");  --E17E
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000000000000000");  --0
    -- --------------------
    wait for 100 ns;                    -- Time=1200 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("11110110");  --F6
    inChannels(0) <= transport std_logic_vector'("00000000000000010");  --2
    inChannels(1) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(2) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(3) <= transport std_logic_vector'("01110000101111110");  --E17E
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000000000000000");  --0   
    -- --------------------
    wait for 100 ns;                    -- Time=1300 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("11110010");  --F2
    inChannels(0) <= transport std_logic_vector'("00000000000000011");  --3
    inChannels(1) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(2) <= transport std_logic_vector'("01110000101111110");  --E17E
    inChannels(3) <= transport std_logic_vector'("01110000101111110");  --E17E
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000000000000000");  --0
    -- --------------------
    wait for 100 ns;                    -- Time=1400 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("11110010");  --F2
    inChannels(0) <= transport std_logic_vector'("10000000000000100");  --10004
    inChannels(1) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(2) <= transport std_logic_vector'("01110000101111110");  --E17E
    inChannels(3) <= transport std_logic_vector'("01110000101111110");  --E17E
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000000000000000");  --0
    -- --------------------
    wait for 100 ns;                    -- Time=1500 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("11110011");  --F3
    inChannels(0) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(1) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(2) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(3) <= transport std_logic_vector'("01110000101111110");  --E17E
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000000000000000");  --0
    -- --------------------
    wait for 100 ns;                    -- Time=1600 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("11110011");  --F3
    inChannels(0) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(1) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(2) <= transport std_logic_vector'("01110000101111110");  --E17E
    inChannels(3) <= transport std_logic_vector'("00011010000000000");  --3400
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000000000000000");  --0
    -- --------------------
    wait for 100 ns;                    -- Time=1700 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("11110011");  --F3
    inChannels(0) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(1) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(2) <= transport std_logic_vector'("01110000101111110");  --E17E
    inChannels(3) <= transport std_logic_vector'("00000100111000000");  --9C0
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000000000000000");  --0
    -- --------------------
    wait for 100 ns;                    -- Time=1800 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("11110011");  --F3
    inChannels(0) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(1) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(2) <= transport std_logic_vector'("01110000101111110");  --E17E
    inChannels(3) <= transport std_logic_vector'("00111101000010010");  --7A12
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000000000000000");  --0
    -- --------------------
    wait for 100 ns;                    -- Time=1900 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("11110011");  --F3
    inChannels(0) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(1) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(2) <= transport std_logic_vector'("01110000101111110");  --E17E
    inChannels(3) <= transport std_logic_vector'("10100000000000000");  --14000
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000000000000000");  --0
    -- --------------------
    wait for 100 ns;                    -- Time=2000 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("11111011");  --FB
    inChannels(0) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(1) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(2) <= transport std_logic_vector'("01110000101111110");  --E17E
    inChannels(3) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000000000000000");  --0
    -- --------------------
    wait for 100 ns;                    -- Time=2100 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("11111011");  --FB
    inChannels(0) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(1) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(2) <= transport std_logic_vector'("01111110100010000");  --FD10
    inChannels(3) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000000000000000");  --0
    -- --------------------
    wait for 100 ns;                    -- Time=2200 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("11111011");  --FB
    inChannels(0) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(1) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(2) <= transport std_logic_vector'("00001000000000000");  --1000
    inChannels(3) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000000000000000");  --0
    -- --------------------
    wait for 100 ns;                    -- Time=2300 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("11111011");  --FB
    inChannels(0) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(1) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(2) <= transport std_logic_vector'("00000010111111111");  --05FF
    inChannels(3) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000000000000000");  --0
    -- --------------------
    wait for 100 ns;                    -- Time=2400 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("11011011");  --DB
    inChannels(0) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(1) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(2) <= transport std_logic_vector'("00100000000000000");  --4000
    inChannels(3) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00110001000000000");  --6200
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000000000000000");  --0
    -- --------------------
    wait for 100 ns;                    -- Time=2500 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("11011011");  --DB
    inChannels(0) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(1) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(2) <= transport std_logic_vector'("01111110100100011");  --FD23
    inChannels(3) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00110001000000000");  --6200
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000000000000000");  --0
    -- --------------------
    wait for 100 ns;                    -- Time=2600 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("11011011");  --DB
    inChannels(0) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(1) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(2) <= transport std_logic_vector'("00000000111111111");  --1FF
    inChannels(3) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00110001000000000");  --6200
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000000000000000");  --0
    -- --------------------
    wait for 100 ns;                    -- Time=2700 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("11011011");  --DB
    inChannels(0) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(1) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(2) <= transport std_logic_vector'("00000000000000111");  --7
    inChannels(3) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00110001000000000");  --6200
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000000000000000");  --0
    -- --------------------
    wait for 100 ns;                    -- Time=2800 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("11011011");  --DB
    inChannels(0) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(1) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(2) <= transport std_logic_vector'("10000000000000110");  --10006
    inChannels(3) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00110001000000000");  --6200
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000000000000000");  --0
    -- --------------------
    wait for 100 ns;                    -- Time=2900 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("11011111");  --DF
    inChannels(0) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(1) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(2) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(3) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00110001000000000");  --6200
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000000000000000");  --0
    -- --------------------
    wait for 100 ns;                    -- Time=3000 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("11011111");  --DF
    inChannels(0) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(1) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(2) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(3) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00101011001111000");  --5678
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000000000000000");  --0
    -- --------------------
    wait for 100 ns;                    -- Time=3100 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("01011111");  --5F
    inChannels(0) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(1) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(2) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(3) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("10001001000110100");  --11234
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000110000000000");  --C00
    -- --------------------
    wait for 100 ns;                    -- Time=3200 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("01111111");  --7F
    inChannels(0) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(1) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(2) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(3) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000110000000000");  --C00
    -- --------------------
    wait for 100 ns;                    -- Time=3300 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("01111111");  --7F
    inChannels(0) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(1) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(2) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(3) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00010011100010101");  --2715
    -- --------------------
    wait for 100 ns;                    -- Time=3400 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("01111101");  --7D
    inChannels(0) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(1) <= transport std_logic_vector'("01110011100011110");  --E71E
    inChannels(2) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(3) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("11010110011011010");  --1ACDA
    -- --------------------
    wait for 100 ns;                    -- Time=3500 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("11111101");  --FD
    inChannels(0) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(1) <= transport std_logic_vector'("01110011100011110");  --E71E
    inChannels(2) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(3) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000000000000000");  --0
    -- --------------------
    wait for 100 ns;                    -- Time=3600 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("11111101");  --FD
    inChannels(0) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(1) <= transport std_logic_vector'("01111110100100011");  --FD23
    inChannels(2) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(3) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000000000000000");  --0
    -- --------------------
    wait for 100 ns;                    -- Time=3700 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("11111101");  --FD
    inChannels(0) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(1) <= transport std_logic_vector'("00010000001010000");  --2050
    inChannels(2) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(3) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000000000000000");  --0
    -- --------------------
    wait for 100 ns;                    -- Time=3800 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("11111100");  --FC
    inChannels(0) <= transport std_logic_vector'("01110011100011110");  --E71E
    inChannels(1) <= transport std_logic_vector'("00000000111111111");  --1FF
    inChannels(2) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(3) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000000000000000");  --0
    -- --------------------
    wait for 100 ns;                    -- Time=3900 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("11111100");  --FC
    inChannels(0) <= transport std_logic_vector'("01110011100011110");  --E71E
    inChannels(1) <= transport std_logic_vector'("01111110100010000");  --FD10
    inChannels(2) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(3) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000000000000000");  --0
    -- --------------------
    wait for 100 ns;                    -- Time=4000 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("11111100");  --FC
    inChannels(0) <= transport std_logic_vector'("01110011100011110");  --E71E
    inChannels(1) <= transport std_logic_vector'("10000010111111111");  --105FF
    inChannels(2) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(3) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000000000000000");  --0
    -- --------------------
    wait for 100 ns;                    -- Time=4100 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("11111110");  --FE
    inChannels(0) <= transport std_logic_vector'("01110000101111110");  --E17E
    inChannels(1) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(2) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(3) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000000000000000");  --0
    -- --------------------
    wait for 100 ns;                    -- Time=4200 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("11111110");  --FE
    inChannels(0) <= transport std_logic_vector'("01111110100010000");  --FD10
    inChannels(1) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(2) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(3) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000000000000000");  --0
    -- --------------------
    wait for 100 ns;                    -- Time=4300 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("11111110");  --FE
    inChannels(0) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(1) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(2) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(3) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000000000000000");  --0
    -- --------------------
    wait for 100 ns;                    -- Time=4400 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("11111110");  --FE
    inChannels(0) <= transport std_logic_vector'("00000010111111111");  --05FF
    inChannels(1) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(2) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(3) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000000000000000");  --0
    -- --------------------
    wait for 100 ns;                    -- Time=4500 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("11111110");  --FE
    inChannels(0) <= transport std_logic_vector'("10111000000000000");  --17000
    inChannels(1) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(2) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(3) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000000000000000");  --0
    -- --------------------
    wait for 100 ns;                    -- Time=4600 ns
    SBA           <= transport std_logic_vector'("00000101");  --5
    empty         <= transport std_logic_vector'("11111111");  --FF
    inChannels(0) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(1) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(2) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(3) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(4) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(5) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(6) <= transport std_logic_vector'("00000000000000000");  --0
    inChannels(7) <= transport std_logic_vector'("00000000000000000");  --0
    -- --------------------
    wait for 110 ns;                    -- Time=4710 ns
    -- --------------------
  end process;
end testbench_arch;

configuration decap_environment_cfg of testbench is
  for testbench_arch
  end for;
end decap_environment_cfg;



