library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
use ieee.numeric_std.all;
use work.types.all;

library ieee;
use IEEE.STD_LOGIC_TEXTIO.all;
use STD.TEXTIO.all;

entity testbench is
end testbench;

architecture testbench_arch of testbench is
-- If you get a compiler error on the following line,
-- from the menu do Options->Configuration select VHDL 87
  component Queue
    port (
      clk        : in  std_logic;
      reset      : in  std_logic;
      load       : in  std_logic;
      flit_array : in  outflitRegType;
      outFlit    : out std_logic_vector (16 downto 0);
      ready      : out std_logic;
      full       : in  std_logic;
      put        : out std_logic
      );
  end component;

  signal clk        : std_logic;
  signal reset      : std_logic;
  signal load       : std_logic;
  signal flit_array : outflitRegType;
  signal outFlit    : std_logic_vector (16 downto 0);
  signal ready      : std_logic;
  signal full       : std_logic;
  signal put        : std_logic;

begin
  UUT : Queue
    port map (
      clk        => clk,
      reset      => reset,
      load       => load,
      flit_array => flit_array,
      outFlit    => outFlit,
      ready      => ready,
      full       => full,
      put        => put
      );

  process                               -- clock process for clk,
  begin
    CLOCK_LOOP : loop
      clk <= transport '0';
      wait for 10 ns;
      clk <= transport '1';
      wait for 10 ns;
      wait for 40 ns;
      clk <= transport '0';
      wait for 40 ns;
    end loop CLOCK_LOOP;
  end process;

  process                               -- Process for clk



  begin
    -- --------------------
    reset         <= transport '1';
    load          <= transport '0';
    flit_array(0) <= transport std_logic_vector'("00000000000000000");  --0
    flit_array(1) <= transport std_logic_vector'("00000000000000000");  --0
    flit_array(2) <= transport std_logic_vector'("00000000000000000");  --0
    flit_array(3) <= transport std_logic_vector'("00000000000000000");  --0
    flit_array(4) <= transport std_logic_vector'("00000000000000000");  --0
    flit_array(5) <= transport std_logic_vector'("00000000000000000");  --0
    flit_array(6) <= transport std_logic_vector'("00000000000000000");  --0
    flit_array(7) <= transport std_logic_vector'("00000000000000000");  --0
    flit_array(8) <= transport std_logic_vector'("00000000000000000");  --0
    full          <= transport '0';
    -- --------------------
    wait for 100 ns;                    -- Time=100 ns
    reset         <= transport '0';
    -- --------------------
    wait for 100 ns;                    -- Time=200 ns
    load          <= transport '1';
    flit_array(0) <= transport std_logic_vector'("00101010111000000");  --55C0
    flit_array(1) <= transport std_logic_vector'("01111101000100011");  --FA23
    flit_array(2) <= transport std_logic_vector'("00010000001010000");  --2050
    flit_array(3) <= transport std_logic_vector'("00000100100110100");  --0934
    flit_array(4) <= transport std_logic_vector'("00001001000110100");  --1234
    flit_array(5) <= transport std_logic_vector'("10101011001111000");  --15678
    flit_array(6) <= transport std_logic_vector'("00000000000000000");  --0
    flit_array(7) <= transport std_logic_vector'("00000000000000000");  --0
    flit_array(8) <= transport std_logic_vector'("00000000000000000");  --0

    -- --------------------
    wait for 100 ns;                    -- Time=300 ns
    load <= transport '0';
    flit_array(0) <= transport std_logic_vector'("00000000000000000");  --0
    flit_array(1) <= transport std_logic_vector'("00000000000000000");  --0
    flit_array(2) <= transport std_logic_vector'("00000000000000000");  --0
    flit_array(3) <= transport std_logic_vector'("00000000000000000");  --0
    flit_array(4) <= transport std_logic_vector'("00000000000000000");  --0
    flit_array(5) <= transport std_logic_vector'("00000000000000000");  --0
    flit_array(6) <= transport std_logic_vector'("00000000000000000");  --0
    flit_array(7) <= transport std_logic_vector'("00000000000000000");  --0
    flit_array(8) <= transport std_logic_vector'("00000000000000000");  --0

    full <= transport '0';
    -- --------------------
    wait for 100 ns;                    -- Time=300 ns
    load <= transport '0';
    full <= transport '0';
    -- --------------------
    wait for 100 ns;                    -- Time=300 ns
    load <= transport '0';
    full <= transport '1';
    -- --------------------
    wait for 100 ns;                    -- Time=300 ns
    load <= transport '0';
    full <= transport '0';
    -- --------------------
    wait for 100 ns;                    -- Time=300 ns
    load <= transport '0';
    full <= transport '0';
    -- --------------------
    wait for 100 ns;                    -- Time=300 ns
    load <= transport '0';
    full <= transport '1';
    -- --------------------
    wait for 100 ns;                    -- Time=300 ns
    load <= transport '0';
    full <= transport '0';
    -- --------------------
    wait for 100 ns;                    -- Time=300 ns
    load <= transport '0';
    full <= transport '0';

--  --------------------
    wait for 110 ns;                    -- Time=410 ns
    -- --------------------
  end process;
end testbench_arch;

configuration Queue_cfg of testbench is
  for testbench_arch
end for;
end Queue_cfg;
