library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_ARITH.all;
use IEEE.STD_LOGIC_UNSIGNED.all;
use IEEE.NUMERIC_STD.all;
library WORK;
use WORK.TYPES.all;
use IEEE.STD_LOGIC_TEXTIO.all;
use STD.TEXTIO.all;

entity test_scheduler is
end test_scheduler;

architecture testbench_arch of test_scheduler is
  component scheduler
    port (
      clk         : in  std_logic;
      reset       : in  std_logic;
      inFlit      : in  std_logic_vector (16 downto 0);
      empty       : in  std_logic_vector (7 downto 0);
      get         : out std_logic_vector (7 downto 0);
      inChSel     : out std_logic_vector (2 downto 0);
      inChPri : out Priority);
  end component;

--   component clock
--     generic (period :     time      := 50 ns);
--     port (clk    : out std_logic := '0');
--   end component;

  signal clk         : std_logic;
  signal reset       : std_logic;
  signal inFlit      : std_logic_vector (16 downto 0);
  signal empty       : std_logic_vector (7 downto 0);
  signal get         : std_logic_vector (7 downto 0);
  signal inChSel     : std_logic_vector (2 downto 0);
  signal inChPri : Priority;
  signal pk_received : std_logic;

begin

  
  UUT: component scheduler
    port map (
      clk         => clk,
      reset       => reset,
      inFlit      => inFlit,
      empty       => empty,
      get         => get,
      inChSel     => inChSel,
      inChPri => inChPri);

 PROCESS                              -- clock process for clk,
      BEGIN
              CLOCK_LOOP : LOOP
              clk <= transport '0';
              WAIT FOR 10 ns;
              clk <= transport '1';
              WAIT FOR 10 ns;
              WAIT FOR 40 ns;
              clk <= transport '0';
              WAIT FOR 40 ns;
              END LOOP CLOCK_LOOP;
      END PROCESS;


--  --   clock_signal : component clock
--  --     port map (
--  --       clk => clk);

   process                               -- Process for clk


  begin

--     -- --------------------
--      reset  <= transport '1';
--      inFlit <= transport std_logic_vector'("00000000000000000");  --0
--      empty  <= transport std_logic_vector'("11111111");  --0
--      -- --------------------
--      wait for 100 ns;                    -- Time=100 ns
--      reset  <= transport '0';
--      inFlit <= transport std_logic_vector'("00001001000110100");  --1234
--      empty  <= transport std_logic_vector'("10110111");  --b7
--      -- --------------------
--      wait for 100 ns;                    -- Time=200 ns
--      inFlit <= transport std_logic_vector'("10010001000110100");  --12234
--      empty  <= transport std_logic_vector'("10110111");  --b7
--      -- --------------------
--      wait for 100 ns;                    -- Time=300 ns
--      inFlit <= transport std_logic_vector'("00001001000110100");  --1234
--      empty  <= transport std_logic_vector'("11100111");  --e7
--      -- --------------------
--      wait for 100 ns;                    -- Time=400 ns
--      inFlit <= transport std_logic_vector'("10010001000110100");  --12234
--      empty  <= transport std_logic_vector'("11100111");  --e7
--      -- --------------------
--      wait for 100 ns;                    -- Time=500 ns
--      inFlit <= transport std_logic_vector'("00001001000110100");  --1234
--      empty  <= transport std_logic_vector'("11010111");  --d7
--      -- --------------------
--      wait for 100 ns;                    -- Time=600 ns
--      inFlit <= transport std_logic_vector'("10010001000110100");  --12234
--      empty  <= transport std_logic_vector'("11010111");  --d7
--      -- --------------------
--      wait for 100 ns;                    -- Time=700 ns
--      inFlit <= transport std_logic_vector'("00001001000110100");  --1234
--      empty  <= transport std_logic_vector'("11110101");  --f5
--      -- --------------------
--      wait for 100 ns;                    -- Time=800 ns
--      inFlit <= transport std_logic_vector'("10010001000110100");  --12234
--      empty  <= transport std_logic_vector'("01110101");  --75
--      -- --------------------
--      wait for 100 ns;                    -- Time=900 ns
--      inFlit <= transport std_logic_vector'("00001001000110100");  --1234
--      empty  <= transport std_logic_vector'("01111101");  --7d
--      -- --------------------
--      wait for 100 ns;                    -- Time=1000 ns
--      inFlit <= transport std_logic_vector'("10010001000110100");  --12234
--      empty  <= transport std_logic_vector'("01111101");  --7d
--      -- --------------------
--      wait for 100 ns;                    -- Time=1100 ns
--      inFlit <= transport std_logic_vector'("00001001000110100");  --1234
--      empty  <= transport std_logic_vector'("11111101");  --fd
--      -- --------------------
--      WAIT FOR 100 ns;                    -- Time=1200 ns
--      inFlit <= transport std_logic_vector'("10010001000110100");  --12234
--      empty  <= transport std_logic_vector'("11111101");  --dd
--      -- --------------------
--      WAIT FOR 100 ns;                    -- Time=1200 ns
--      inFlit <= transport std_logic_vector'("00000000000000000");  --12234
--      empty  <= transport std_logic_vector'("11111111");  --dd

--      -- --------------------
--      WAIT FOR 100 ns;                    -- Time=1200 ns
--      inFlit <= transport std_logic_vector'("00001001000110100");  --01234
--      empty  <= transport std_logic_vector'("11011111");  --dd
--      -- --------------------
--      WAIT FOR 100 ns;                    -- Time=1200 ns
--      inFlit <= transport std_logic_vector'("10010001000110100");  --12234
--      empty  <= transport std_logic_vector'("11011111");  --dd
--      -- --------------------
--      WAIT FOR 120 ns;                    -- Time=1320 ns
--      -- --------------------

    
--   -- 	-- --------------------
  		reset <= transport '1';

 		empty <= transport std_logic_vector'("11111111"); --FF
 		inFlit <= transport std_logic_vector'("00000000000000000"); --0000
  		-- --------------------
  		WAIT FOR 100 ns; -- Time=100 ns
  		reset <= transport '0';		
  		empty <= transport std_logic_vector'("11111011"); --F3
  		inFlit <= transport std_logic_vector'("01110011100011110"); --E71E
  		-- --------------------
  		WAIT FOR 100 ns; -- Time=100 ns
	
  		empty <= transport std_logic_vector'("11010011"); --B3
  		inFlit <= transport std_logic_vector'("01111110100100011"); --FD23
  		-- --------------------
  		WAIT FOR 100 ns; -- Time=200 ns

  		empty <= transport std_logic_vector'("11010011"); --A3
  		inFlit <= transport std_logic_vector'("00100000001010000"); --4050
  		-- --------------------
  		WAIT FOR 100 ns; -- Time=300 ns
	
  		empty <= transport std_logic_vector'("11010011"); --A3
  		inFlit <= transport std_logic_vector'("00000000111111111"); --1FF
  		-- --------------------
  		WAIT FOR 100 ns; -- Time=400 ns

  		empty <= transport std_logic_vector'("11010011"); --A3
  		inFlit <= transport std_logic_vector'("00000000000000001"); --1
  		-- --------------------
  		WAIT FOR 100 ns; -- Time=500 ns
	
 		empty <= transport std_logic_vector'("11010011"); --A3
 		inFlit <= transport std_logic_vector'("00000000000000010"); --2
  		-- --------------------
  		WAIT FOR 100 ns; -- Time=600 ns
  		empty <= transport std_logic_vector'("11010011"); --A3
 		inFlit <= transport std_logic_vector'("00000000000000011"); --3
 		-- --------------------
  		WAIT FOR 100 ns; -- Time=700 ns
	
  		empty <= transport std_logic_vector'("11010011"); --A3
  		inFlit <= transport std_logic_vector'("10000000000000100"); --10004
 		-- --------------------
 		WAIT FOR 100 ns; -- Time=800 ns

  		empty <= transport std_logic_vector'("11010111"); --A3
  		inFlit <= transport std_logic_vector'("01110000101111110"); --E17E
  		-- --------------------
  		WAIT FOR 100 ns; -- Time=900 ns
	
  		empty <= transport std_logic_vector'("11010111"); --A3
  		inFlit <= transport std_logic_vector'("01111110100010000"); --FD10
  		-- --------------------
  		WAIT FOR 100 ns; -- Time=1000 ns
	
  		empty <= transport std_logic_vector'("11010111"); --A3
  		inFlit <= transport std_logic_vector'("00001000000000000"); --1000
  		-- --------------------
  		WAIT FOR 100 ns; -- Time=1100 ns
	
  		empty <= transport std_logic_vector'("11010111"); --A3
  		inFlit <= transport std_logic_vector'("00000000111111111"); --1FF
  		-- --------------------
  		WAIT FOR 100 ns; -- Time=1200 ns
	
  		empty <= transport std_logic_vector'("11010111"); --A3
  		inFlit <= transport std_logic_vector'("00100000000000000"); --4000
  		-- --------------------
  		WAIT FOR 100 ns; -- Time=1300 ns
	
  		empty <= transport std_logic_vector'("11010111"); --A3
  		inFlit <= transport std_logic_vector'("01111110100100011"); --FD23
  		-- --------------------
  		WAIT FOR 100 ns; -- Time=1400 ns
	
  		empty <= transport std_logic_vector'("11010111"); --A3
  		inFlit <= transport std_logic_vector'("00000000111111111"); --1FF
  		-- --------------------
 		WAIT FOR 100 ns; -- Time=1500 ns
	
  		empty <= transport std_logic_vector'("11010111"); --A3
 		inFlit <= transport std_logic_vector'("00000000000000111"); --7
  		-- --------------------
 		WAIT FOR 100 ns; -- Time=1600 ns
	
  		empty <= transport std_logic_vector'("11010111"); --A3
  		inFlit <= transport std_logic_vector'("10000000000000110"); --10006

                WAIT FOR 100 ns; -- Time=1600 ns
                -- --------------------
	        empty <= transport std_logic_vector'("11110111"); --A3
  		inFlit <= transport std_logic_vector'("01110000101111110"); --E17E
  		-- --------------------
  		WAIT FOR 100 ns; -- Time=900 ns
	
  		empty <= transport std_logic_vector'("11110111"); --A3
  		inFlit <= transport std_logic_vector'("01111110100010000"); --FD10
  		-- --------------------
  		WAIT FOR 100 ns; -- Time=1000 ns
	
  		empty <= transport std_logic_vector'("11110111"); --A3
  		inFlit <= transport std_logic_vector'("00001000000000000"); --1000
  		-- --------------------
  		WAIT FOR 100 ns; -- Time=1100 ns
	
  		empty <= transport std_logic_vector'("11110111"); --A3
  		inFlit <= transport std_logic_vector'("00000000111111111"); --1FF
  		-- --------------------
  		WAIT FOR 100 ns; -- Time=1200 ns
	
  		empty <= transport std_logic_vector'("11110111"); --A3
  		inFlit <= transport std_logic_vector'("00100000000000000"); --4000
  		-- --------------------
  		WAIT FOR 100 ns; -- Time=1300 ns
	
  		empty <= transport std_logic_vector'("11110111"); --A3
  		inFlit <= transport std_logic_vector'("01111110100100011"); --FD23
  		-- --------------------
  		WAIT FOR 100 ns; -- Time=1400 ns
	
  		empty <= transport std_logic_vector'("11110111"); --A3
  		inFlit <= transport std_logic_vector'("00000000111111111"); --1FF
  		-- --------------------
 		WAIT FOR 100 ns; -- Time=1500 ns
	
  		empty <= transport std_logic_vector'("11110111"); --A3
 		inFlit <= transport std_logic_vector'("00000000000000111"); --7
  		-- --------------------
 		WAIT FOR 100 ns; -- Time=1600 ns
	
  		empty <= transport std_logic_vector'("11110111"); --A3
  		inFlit <= transport std_logic_vector'("10000000000000110"); --10006


-- --------------------
  		WAIT FOR 110 ns; -- Time=1710 ns
--  		-- --------------------
    
    
  END PROCESS;
END testbench_arch;

CONFIGURATION scheduler_cfg OF test_scheduler IS
  FOR testbench_arch
  END FOR;
END scheduler_cfg;
